// $ANTLR 2.7.2: "grammar.g" -> "GrammarParser.java"$

package antlr.util;

import antlr.*;
import antlr.collections.*;
import java.io.*;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import java.util.Hashtable;
import antlr.ASTFactory;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

/** Parse simple grammars */
public class GrammarParser extends antlr.LLkParser       implements GrammarTokenTypes
 {

public static void main(String[] args) {
	System.out.println(GrammarParser.toAST(args[0]).toStringList());
}

public static AST toAST(String t) {
	GrammarLexer lex = new GrammarLexer(new StringReader(t));
	GrammarParser p = new GrammarParser(lex);
	try {
		p.rules();
		return p.getAST();
	}
	catch (Exception e) {
		System.err.println("Problem with grammar: "+e);
		return null;
	}
}

protected GrammarParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public GrammarParser(TokenBuffer tokenBuf) {
  this(tokenBuf,1);
}

protected GrammarParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public GrammarParser(TokenStream lexer) {
  this(lexer,1);
}

public GrammarParser(ParserSharedInputState state) {
  super(state,1);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

	public final void rules() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST rules_AST = null;
		
		try {      // for error handling
			{
			int _cnt3=0;
			_loop3:
			do {
				if ((LA(1)==RULE_REF)) {
					rule();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					if ( _cnt3>=1 ) { break _loop3; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt3++;
			} while (true);
			}
			rules_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_0);
		}
		returnAST = rules_AST;
	}
	
	public final void rule() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST rule_AST = null;
		Token  r = null;
		AST r_AST = null;
		
		try {      // for error handling
			r = LT(1);
			r_AST = astFactory.create(r);
			astFactory.makeASTRoot(currentAST, r_AST);
			match(RULE_REF);
			r_AST.setType(RULE_DEF);
			match(COLON);
			block();
			astFactory.addASTChild(currentAST, returnAST);
			match(SEMI);
			rule_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_1);
		}
		returnAST = rule_AST;
	}
	
	public final void block() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST block_AST = null;
		AST a1_AST = null;
		AST a2_AST = null;
		
		try {      // for error handling
			alt();
			a1_AST = (AST)returnAST;
			block_AST = (AST)currentAST.root;
			block_AST=astFactory.create(BLOCK,"BLOCK"); block_AST.addChild(a1_AST);
			currentAST.root = block_AST;
			currentAST.child = block_AST!=null &&block_AST.getFirstChild()!=null ?
				block_AST.getFirstChild() : block_AST;
			currentAST.advanceChildToEnd();
			{
			_loop7:
			do {
				if ((LA(1)==OR)) {
					AST tmp3_AST = null;
					tmp3_AST = astFactory.create(LT(1));
					match(OR);
					alt();
					a2_AST = (AST)returnAST;
					block_AST = (AST)currentAST.root;
					block_AST.addChild(a2_AST);
				}
				else {
					break _loop7;
				}
				
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_2);
		}
		returnAST = block_AST;
	}
	
	public final void alt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST alt_AST = null;
		AST e_AST = null;
		
		try {      // for error handling
			alt_AST = (AST)currentAST.root;
			alt_AST=astFactory.create(ALT,"ALT");
			currentAST.root = alt_AST;
			currentAST.child = alt_AST!=null &&alt_AST.getFirstChild()!=null ?
				alt_AST.getFirstChild() : alt_AST;
			currentAST.advanceChildToEnd();
			{
			_loop10:
			do {
				if ((_tokenSet_3.member(LA(1)))) {
					element();
					e_AST = (AST)returnAST;
					alt_AST = (AST)currentAST.root;
					alt_AST.addChild(e_AST);
				}
				else {
					break _loop10;
				}
				
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_4);
		}
		returnAST = alt_AST;
	}
	
	public final void element() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST element_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case TOKEN_REF:
			{
				AST tmp4_AST = null;
				tmp4_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp4_AST);
				match(TOKEN_REF);
				element_AST = (AST)currentAST.root;
				break;
			}
			case RULE_REF:
			{
				AST tmp5_AST = null;
				tmp5_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp5_AST);
				match(RULE_REF);
				element_AST = (AST)currentAST.root;
				break;
			}
			case STRING:
			{
				AST tmp6_AST = null;
				tmp6_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp6_AST);
				match(STRING);
				element_AST = (AST)currentAST.root;
				break;
			}
			case LPAREN:
			{
				ebnf();
				astFactory.addASTChild(currentAST, returnAST);
				element_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_5);
		}
		returnAST = element_AST;
	}
	
	public final void ebnf() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST ebnf_AST = null;
		
		try {      // for error handling
			match(LPAREN);
			block();
			astFactory.addASTChild(currentAST, returnAST);
			match(RPAREN);
			{
			switch ( LA(1)) {
			case QUESTION:
			{
				AST tmp9_AST = null;
				tmp9_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp9_AST);
				match(QUESTION);
				break;
			}
			case STAR:
			{
				AST tmp10_AST = null;
				tmp10_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp10_AST);
				match(STAR);
				break;
			}
			case PLUS:
			{
				AST tmp11_AST = null;
				tmp11_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp11_AST);
				match(PLUS);
				break;
			}
			case RULE_REF:
			case SEMI:
			case OR:
			case TOKEN_REF:
			case STRING:
			case LPAREN:
			case RPAREN:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			ebnf_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_5);
		}
		returnAST = ebnf_AST;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"RULE_DEF",
		"BLOCK",
		"ALT",
		"RULE_REF",
		"COLON",
		"SEMI",
		"OR",
		"TOKEN_REF",
		"STRING",
		"LPAREN",
		"RPAREN",
		"QUESTION",
		"STAR",
		"PLUS",
		"NEWLINE",
		"WS"
	};
	
	protected void buildTokenTypeASTClassMap() {
		tokenTypeToASTClassMap=null;
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 2L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 130L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 16896L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	private static final long[] mk_tokenSet_3() {
		long[] data = { 14464L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
	private static final long[] mk_tokenSet_4() {
		long[] data = { 17920L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
	private static final long[] mk_tokenSet_5() {
		long[] data = { 32384L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_5 = new BitSet(mk_tokenSet_5());
	
	}
