// $ANTLR 2.7.2: "grammar.tree.g" -> "GrammarTreeParser.java"$

package antlr.util;

import antlr.*;
import antlr.collections.*;
import java.io.*;
import org.antlr.stringtemplate.*;

import antlr.TreeParser;
import antlr.Token;
import antlr.collections.AST;
import antlr.RecognitionException;
import antlr.ANTLRException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.collections.impl.BitSet;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;


/** Define just so other tree parsers can inherit and get
 *  vocab symbols...must have at least one rule.
 */
public class GrammarTreeParser extends antlr.TreeParser       implements GrammarTreeParserTokenTypes
 {
public GrammarTreeParser() {
	tokenNames = _tokenNames;
}

	public final String  rules(AST _t) throws RecognitionException {
		String r=null;
		
		AST rules_AST_in = (AST)_t;
		
		try {      // for error handling
			{
			int _cnt3=0;
			_loop3:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==RULE_DEF)) {
					rule(_t);
					_t = _retTree;
				}
				else {
					if ( _cnt3>=1 ) { break _loop3; } else {throw new NoViableAltException(_t);}
				}
				
				_cnt3++;
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return r;
	}
	
	public final void rule(AST _t) throws RecognitionException {
		
		AST rule_AST_in = (AST)_t;
		
		try {      // for error handling
			AST __t5 = _t;
			AST tmp1_AST_in = (AST)_t;
			match(_t,RULE_DEF);
			_t = _t.getFirstChild();
			block(_t);
			_t = _retTree;
			_t = __t5;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final String  block(AST _t) throws RecognitionException {
		String r=null;
		
		AST block_AST_in = (AST)_t;
		
		try {      // for error handling
			AST __t7 = _t;
			AST tmp2_AST_in = (AST)_t;
			match(_t,BLOCK);
			_t = _t.getFirstChild();
			{
			int _cnt9=0;
			_loop9:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==ALT)) {
					alt(_t);
					_t = _retTree;
				}
				else {
					if ( _cnt9>=1 ) { break _loop9; } else {throw new NoViableAltException(_t);}
				}
				
				_cnt9++;
			} while (true);
			}
			_t = __t7;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return r;
	}
	
	public final void alt(AST _t) throws RecognitionException {
		
		AST alt_AST_in = (AST)_t;
		
		try {      // for error handling
			AST __t11 = _t;
			AST tmp3_AST_in = (AST)_t;
			match(_t,ALT);
			_t = _t.getFirstChild();
			{
			_loop13:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_tokenSet_0.member(_t.getType()))) {
					element(_t);
					_t = _retTree;
				}
				else {
					break _loop13;
				}
				
			} while (true);
			}
			_t = __t11;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void element(AST _t) throws RecognitionException {
		
		AST element_AST_in = (AST)_t;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case TOKEN_REF:
			{
				AST tmp4_AST_in = (AST)_t;
				match(_t,TOKEN_REF);
				_t = _t.getNextSibling();
				break;
			}
			case RULE_REF:
			{
				AST tmp5_AST_in = (AST)_t;
				match(_t,RULE_REF);
				_t = _t.getNextSibling();
				break;
			}
			case STRING:
			{
				AST tmp6_AST_in = (AST)_t;
				match(_t,STRING);
				_t = _t.getNextSibling();
				break;
			}
			case BLOCK:
			case QUESTION:
			case STAR:
			case PLUS:
			{
				ebnf(_t);
				_t = _retTree;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	public final void ebnf(AST _t) throws RecognitionException {
		
		AST ebnf_AST_in = (AST)_t;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case QUESTION:
			{
				AST __t16 = _t;
				AST tmp7_AST_in = (AST)_t;
				match(_t,QUESTION);
				_t = _t.getFirstChild();
				block(_t);
				_t = _retTree;
				_t = __t16;
				_t = _t.getNextSibling();
				break;
			}
			case STAR:
			{
				AST __t17 = _t;
				AST tmp8_AST_in = (AST)_t;
				match(_t,STAR);
				_t = _t.getFirstChild();
				block(_t);
				_t = _retTree;
				_t = __t17;
				_t = _t.getNextSibling();
				break;
			}
			case PLUS:
			{
				AST __t18 = _t;
				AST tmp9_AST_in = (AST)_t;
				match(_t,PLUS);
				_t = _t.getFirstChild();
				block(_t);
				_t = _retTree;
				_t = __t18;
				_t = _t.getNextSibling();
				break;
			}
			case BLOCK:
			{
				block(_t);
				_t = _retTree;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"RULE_DEF",
		"BLOCK",
		"ALT",
		"RULE_REF",
		"COLON",
		"SEMI",
		"OR",
		"TOKEN_REF",
		"STRING",
		"LPAREN",
		"RPAREN",
		"QUESTION",
		"STAR",
		"PLUS",
		"NEWLINE",
		"WS"
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 235680L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	}
	
