// $ANTLR 2.7.2a3 (20020914-1): "tree.g" -> "LispTreeParser.java"$

package antlr.util;

import antlr.*;
import antlr.collections.*;
import java.io.*;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

/** Parse lisp tree strings, convert to AST. */
public class LispTreeParser extends antlr.LLkParser
       implements LispTreeParserTokenTypes
 {

public static AST toAST(String t) {
	LispTreeLexer lex = new LispTreeLexer(new StringReader(t));
	LispTreeParser p = new LispTreeParser(lex);
	try {
		p.tree();
		return p.getAST();
	}
	catch (Exception e) {
		return null;
	}
}

protected LispTreeParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public LispTreeParser(TokenBuffer tokenBuf) {
  this(tokenBuf,1);
}

protected LispTreeParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public LispTreeParser(TokenStream lexer) {
  this(lexer,1);
}

public LispTreeParser(ParserSharedInputState state) {
  super(state,1);
  tokenNames = _tokenNames;
}

	public final void tree() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST tree_AST = null;
		
		try {      // for error handling
			match(LPAREN);
			{
			switch ( LA(1)) {
			case WORD:
			{
				AST tmp2_AST = null;
				tmp2_AST = (AST)astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp2_AST);
				match(WORD);
				break;
			}
			case STRING:
			{
				AST tmp3_AST = null;
				tmp3_AST = (AST)astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp3_AST);
				match(STRING);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			_loop4:
			do {
				if (((LA(1) >= LPAREN && LA(1) <= STRING))) {
					element();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop4;
				}
				
			} while (true);
			}
			match(RPAREN);
			tree_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_0);
		}
		returnAST = tree_AST;
	}
	
	public final void element() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST element_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case WORD:
			case STRING:
			{
				atom();
				astFactory.addASTChild(currentAST, returnAST);
				element_AST = (AST)currentAST.root;
				break;
			}
			case LPAREN:
			{
				tree();
				astFactory.addASTChild(currentAST, returnAST);
				element_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_0);
		}
		returnAST = element_AST;
	}
	
	public final void atom() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST atom_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case WORD:
			{
				AST tmp5_AST = null;
				tmp5_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp5_AST);
				match(WORD);
				atom_AST = (AST)currentAST.root;
				break;
			}
			case STRING:
			{
				AST tmp6_AST = null;
				tmp6_AST = (AST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp6_AST);
				match(STRING);
				atom_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_0);
		}
		returnAST = atom_AST;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"LPAREN",
		"WORD",
		"STRING",
		"RPAREN",
		"NEWLINE",
		"WS"
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 240L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	
	}
